﻿{
    "translatorID": "64bd49d6-8412-4337-892a-0b2e2a16cd64",
    "translatorType": 4,
    "label": "Filimo",
    "creator": "CRCIS",
    "target": ".*filimo.com/",
    "minVersion": "2.0",
    "maxVersion": "",
    "priority": 100,
    "inRepository": true,
    "browserSupport": "gcsibv",
    "lastUpdated": "2015-07-28 11:08:01"
}

//<abszh>
function detectWeb(doc, url)  {
    var result=false;
    if (url.match(/.*filimo.com\/result\.*/)) {
        result="multiple";
    }
    else if (url.match(/.*filimo.com\/m.*/)) {
        result="film";
    }
    return result;
}




function doWeb(doc, url) {
    var namespace = doc.documentElement.namespaceURI;
    var nsResolver = namespace ? function(prefix) {
        if (prefix == 'x') return namespace; else return null;
    } : null;


    var items = new Object();
    var nextTitle;



    if (detectWeb(doc, url) == "multiple") {
        scrapeMultiple(doc,url);
    } else {
        scrapeSingle(doc,url);
        Zotero.done();
    }
    Zotero.wait();
}

function scrapeMultiple(doc,url) {
    var itemList = ZU.xpath(doc,"//div[@id='starSeason_listtitle']/a/script");
    var itemRef = ZU.xpath(doc,"//div[@id='starSeason_listtitle']/a");
    var items = {};
    for(var i=0, n=itemList.length; i<n; i++) {
        items[itemRef[i].href] = itemList[i].textContent.replace(/^.*\[\'name\'\][\s]*\=[\s]*\'/,"").replace(/\';.*/,"");
    }

    Zotero.selectItems(items, function(selectedItems) {
        if(!selectedItems) return true;

        var itemObjs = new Array();

        for (var i in selectedItems) {
            ZU.processDocuments(i, scrapeSingle);
        }
    });
}



function scrapeSingle(doc,url) {
    Zotero.debug("scrapeSingle");

    var namespace = doc.documentElement.namespaceURI;
    var nsResolver = namespace ? function(prefix) {
        if (prefix == 'x') return namespace; else return null;
    } : null;
    var authorsCount;

    var castCount=doc.evaluate("count(//div[@id='v2-movie-cast-wrapper']/div)",doc,nsResolver, XPathResult.ANY_TYPE, null);

    var newItem = new Zotero.Item("film");
    newItem.url = doc.location.href;

    var td1;
    var td2;

    var XPath1="//div[@id='v2-movie-cast-wrapper']/div[@class='v2-movie-cast']/b";
    var XPath2="//div[@id='v2-movie-cast-wrapper']/div[@class='v2-movie-cast']/span/a";
    var theXPathObject1=doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
    var theXPathObject2=doc.evaluate(XPath2,doc,nsResolver, XPathResult.ANY_TYPE, null);

    var i=1;
    while (td1=theXPathObject1.iterateNext()) {


        td2=theXPathObject2.iterateNext();
        if (!td2) break;
        authorsCount=doc.evaluate("count(//div[@id='v2-movie-cast-wrapper']/div["+i+"]/span/a)",doc,nsResolver, XPathResult.ANY_TYPE, null);

        i++;
        var td1Text=td1.textContent;
        var td2Text=td2.textContent;
        Zotero.debug("td1Text: "+td1Text);
        Zotero.debug("td2Text: "+td2Text);
        if (td1Text.match(/کارگردان/g)) {
            newItem.creators.push(Zotero.Utilities.cleanAuthor(td2Text, "director",false));
            for(var j=0;j<authorsCount.numberValue-1;j++){
                td2=theXPathObject2.iterateNext();
                td2Text=td2.textContent;
                newItem.creators.push(Zotero.Utilities.cleanAuthor(td2Text, "director",false));
            }
        }
        else if (td1Text.match(/تهیه کننده/g)) {
            newItem.creators.push(Zotero.Utilities.cleanAuthor(td2Text, "producer",false));
            for(var j=0;j<authorsCount.numberValue-1;j++){
                td2=theXPathObject2.iterateNext();
                td2Text=td2.textContent;
                newItem.creators.push(Zotero.Utilities.cleanAuthor(td2Text, "producer",false));
            }
        }
        else if (td1Text.match(/فیلم نامه نویس/g)) {
            newItem.creators.push(Zotero.Utilities.cleanAuthor(td2Text, "scriptwriter",false));
            for(var j=0;j<authorsCount.numberValue-1;j++){
                td2=theXPathObject2.iterateNext();
                td2Text=td2.textContent;
                newItem.creators.push(Zotero.Utilities.cleanAuthor(td2Text, "scriptwriter",false));
            }
        }
        else{
            for(var j=0;j<authorsCount.numberValue-1;j++){
                //do nothing,only pass them
                td2=theXPathObject2.iterateNext();
            }
        }
    }

    //title
    XPath1 = '//HEAD/title';
    theXPathObject1=doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
    newItem.title = theXPathObject1.iterateNext().textContent;
    //genre
    XPath1 = '//div[@id="v2-movie-categories"]';// /a
    theXPathObject1=doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
    newItem.genre = theXPathObject1.iterateNext().textContent;
    //date
    XPath2 = '//div[@id="v2-movie-brief-info-container"]/div[2]';
    theXPathObject2=doc.evaluate(XPath2,doc,nsResolver, XPathResult.ANY_TYPE, null);
    newItem.date = theXPathObject2.iterateNext().textContent.replace(/-.*$/,'');
    //abstract
    XPath2 = '//div[@id="v2-movie-content-desc"]';
    theXPathObject2=doc.evaluate(XPath2,doc,nsResolver, XPathResult.ANY_TYPE, null);
    newItem.abstractNote = theXPathObject2.iterateNext().textContent.trim();


    newItem.complete();
    Zotero.debug("newItem: "+newItem);
}


//XPath1: XPath to labels ("Title:", "Author:","Publisher:", ...)
//XPath2: XPath to contents ("Story of Civilization","Durant, Will",...)
function scrape(doc,url,XPath1,XPath2) {
    var namespace = doc.documentElement.namespaceURI;
    var nsResolver = namespace ? function(prefix) {
        if (prefix == 'x') return namespace; else return null;
    } : null;

    var newItem = new Zotero.Item("film");
    newItem.url = doc.location.href;

    var td1;
    var td2;

    var theXPathObject1=doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
    var theXPathObject2=doc.evaluate(XPath2,doc,nsResolver, XPathResult.ANY_TYPE, null);

    while (td1=theXPathObject1.iterateNext()) {
        td2=theXPathObject2.iterateNext();
        if (!td2) break;
        var td1Text=td1.textContent;
        var td2Text=td2.textContent;
        Zotero.debug("td1Text: "+td1Text);
        Zotero.debug("td2Text: "+td2Text);
        if (td1Text.match(/کارگردان/g)) {
            newItem.creators.push(Zotero.Utilities.cleanAuthor(td2Text, "director",true));
        }
        else if (td1Text.match(/فیلم نامه نویس/g)) {
            newItem.creators.push(Zotero.Utilities.cleanAuthor(td2Text, "scriptwriter",true));
            while(td2=theXPathObject2.iterateNext()){
                td2Text=td2.textContent;
                newItem.creators.push(Zotero.Utilities.cleanAuthor(td2Text, "scriptwriter",true));
            }
        }
        else{
            while(td2=theXPathObject2.iterateNext()){
                //do nothing,only pass them
            }
        }
    }

    //title
    XPath1 = '//HEAD/title';
    theXPathObject1=doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
    newItem.title = theXPathObject1.iterateNext().textContent;
    //genre
    XPath1 = '//div[@id="v2-movie-categories"]/a';
    theXPathObject1=doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
    newItem.genre = theXPathObject1.iterateNext().textContent;
    //date
    XPath2 = '//div[@id="v2-movie-brief-info-container"]/div[2]';
    theXPathObject2=doc.evaluate(XPath2,doc,nsResolver, XPathResult.ANY_TYPE, null);
    newItem.date = theXPathObject2.iterateNext().textContent.replace(/-.*$/,'');


    newItem.complete();
    Zotero.debug("newItem: "+newItem);
}

function insertIntoDiv(doc,text) {
    Zotero.debug("inserting");
    var div = doc.getElementById("abszhDiv");
    if (!div) {

        div = doc.createElement("div");
        div.setAttribute("id", "abszhDiv");
        div.setAttribute("name", "abszhDiv");
        div.setAttribute("type", "content");
        div.setAttribute("collapsed", "true");
        body=doc.getElementsByTagName("body")[0];
        body.appendChild(div);
    }
    div.style.display='none';
    div.innerHTML=text;
}