{
    "translatorID": "259c0ace-0eed-49ec-8c0f-fbb6ac313573",
    "label": "Ganjoor",
    "creator": "CRCIS",
    "target": ".*ganjoor.net/",
    "minVersion": "1.0",
    "maxVersion": "",
    "priority": 100,
    "inRepository": true,
    "translatorType": 4,
    "browserSupport": "gcsibv",
    "lastUpdated": "2015-07-05 15:24:26"
}

function detectWeb(doc, url)  {
    var result=false;
    if (url.match(/.*ganjoor.net\/index.php\?s=.*/) || url.match(/.*ganjoor.net\/vazn\/\?v=.*/)) {
        if (getPoemList(doc).length > 0) {
            result="multiple";
        } else {
            result="webpage";
        }
    }
    else if (url.match(/.*ganjoor.net\/*/)) {
        if(isPoem(doc)){
            if(isBook(doc))
                result="book";
            else
                result="bookSection";
        }
        else{
            result="webpage";
        }
    }
    return result;
}

function getPoemList(doc) {
    return ZU.xpath(doc,'//a[@rel="bookmark"]');
}

function isBook(doc){
    var namespace = doc.documentElement.namespaceURI;
    var nsResolver = namespace ? function(prefix) {
        if (prefix == 'x') return namespace; else return null;
    } : null;

    var XPath1="//div[@class='m1']";
    var theXPathObject1= doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
    var temp = theXPathObject1.iterateNext();
    if(temp)
        return false;
    else
    {//نثر
        XPath1="//div[@class='b2']";
        theXPathObject1= doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
        temp = theXPathObject1.iterateNext();
        if(temp)
            return false;
        else
            return true;
    }
}

function isPoem(doc){
    var namespace = doc.documentElement.namespaceURI;
    var nsResolver = namespace ? function(prefix) {
        if (prefix == 'x') return namespace; else return null;
    } : null;

    var XPath1="//a[@rel='bookmark']";
    var theXPathObject1= doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
    var temp = theXPathObject1.iterateNext();
    if(temp)
    {
        //صفحه معرفي شاعر
        XPath1="//div[@class='poem']/div[3]";
        theXPathObject1= doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
        temp = theXPathObject1.iterateNext();
        if(temp){
            if(temp.textContent.indexOf("\u00BB") != -1)
                return true;
            else
                return false;
        }
    }
    else
        return false;
}

function doWeb(doc, url) {
    var namespace = doc.documentElement.namespaceURI;
    var nsResolver = namespace ? function(prefix) {
        if (prefix == 'x') return namespace; else return null;
    } : null;

    var items = new Object();
    var nextTitle;

    if (detectWeb(doc, url) == "multiple") {
        var itemList = getPoemList(doc);
        var items = {};
        for(var i=0, n=itemList.length; i<n; i++) {
            items[itemList[i].href] = itemList[i].textContent;
        }

        Zotero.selectItems(items, function(selectedItems) {
            if(!selectedItems) return true;

            var itemObjs = new Array();

            for (var i in selectedItems) {
                ZU.processDocuments(i, scrape);	//move this out of the loop when ZU.processDocuments is fixed
            }
        });

    }
    else if(detectWeb(doc, url) == "bookSection") {
        scrape(doc,url);
        Zotero.done();
    }
    else if(detectWeb(doc, url) == "webpage"){
        scrapeWebItem(doc,url);
        Zotero.done();
    }
    else if(detectWeb(doc, url) == "book"){
        scrapeBookItem(doc,url);
        Zotero.done();
    }
    Zotero.wait();
}

function scrapeWebItem(doc,url){
    var namespace = doc.documentElement.namespaceURI;
    var nsResolver = namespace ? function(prefix) {
        if (prefix == 'x') return namespace; else return null;
    } : null;

    var itemType="webpage";
    var newItem = new Zotero.Item(itemType);

    newItem.url = doc.location.href;
    newItem.title = doc.title;
    newItem.websiteTitle = "\u06af\u0646\u062c\u0648\u0631";

    newItem.complete();
    Zotero.debug("newItem: "+newItem);
}

function scrape(doc,url) {
    var namespace = doc.documentElement.namespaceURI;
    var nsResolver = namespace ? function(prefix) {
        if (prefix == 'x') return namespace; else return null;
    } : null;

    var itemType="bookSection";
    var newItem = new Zotero.Item(itemType);

    newItem.url = doc.location.href;

    var XPath1="//a[@rel='bookmark']";
    var theXPathObject1= doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
    var title="";
    var temp = theXPathObject1.iterateNext();
    if(temp)
        title = temp.textContent;
    else
        return;

    XPath1="//div[@class='poem']/div[3]/a";
    theXPathObject1= doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
    var i=1;
    while (td1=theXPathObject1.iterateNext()) {
        if(i==1)
            newItem.creators.push(Zotero.Utilities.cleanAuthor(td1.textContent, "author",false));
        else if(i==2)
            newItem.bookTitle = td1.textContent;
        else
            title = td1.textContent+"/"+title;
        i++;
    }
    newItem.title = title;

    XPath1="//div[@class='m1']/p";
    theXPathObject1= doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
    XPath2="//div[@class='m2']/p";
    theXPathObject2= doc.evaluate(XPath2,doc,nsResolver, XPathResult.ANY_TYPE, null);
    var poem="";
    while (td1=theXPathObject1.iterateNext()) {
        td2=theXPathObject2.iterateNext();
        if (!td2) break;
        poem += td1.textContent+"/";
        poem += td2.textContent+"\n";
    }
    newItem.abstractNote = poem;

    newItem.language = "fa";

    newItem.complete();
    Zotero.debug("newItem: "+newItem);
}

function scrapeBookItem(doc,url) {
    var namespace = doc.documentElement.namespaceURI;
    var nsResolver = namespace ? function(prefix) {
        if (prefix == 'x') return namespace; else return null;
    } : null;

    var itemType="book";
    var newItem = new Zotero.Item(itemType);

    newItem.url = doc.location.href;


    var title="";
    XPath1="//div[@class='poem']/div[3]/a";
    theXPathObject1= doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
    var i=1;
    while (td1=theXPathObject1.iterateNext()) {
        if(i==1)
            newItem.creators.push(Zotero.Utilities.cleanAuthor(td1.textContent, "author",false));
        else
            title += "/"+td1.textContent;
        i++;
    }
    newItem.title = title.substring(1);

    newItem.language = "fa";

    newItem.complete();
    Zotero.debug("newItem: "+newItem);
}