{
	"translatorID": "5cc13595-0075-4be6-bd81-9ab1e208aa04",
	"label": "parsquran",
	"creator": "CRCIS",
	"target": "http://(www\\.)?parsquran.com/data/(show|search).php",
	"minVersion": "2.0",
	"maxVersion": "",
	"priority": 100,
	"inRepository": true,
	"translatorType": 4,
	"browserSupport": "gcsib",
	"lastUpdated": "2015-07-01 12:00:13"
}

function detectWeb(doc, url) { 
	return "multiple";
}

function doConvertor(text){
	var ntext = '';
	for (var i=0; i<text.length; i++) {
			if ((text.charCodeAt(i)>=0x06F0) && (text.charCodeAt(i)<=0x06F9)) {
				ntext+=String.fromCharCode(text.charCodeAt(i)-0x06F0+48);
			} else if ((text.charCodeAt(i)>=0x0660) && (text.charCodeAt(i)<=0x0669)) {
				ntext+=String.fromCharCode(text.charCodeAt(i)-0x0660+48);
			} else {
				ntext+=text[i];
			}
		}
	return ntext;
}

function doTranslator(name , url){
	if(name != null && name.match(/هر|All/)){
		name= null;
	}
	if(name == null){
		if(url.match(/lang=eng/)){
			name = "Qarib";
		}else{
			name = "فولادوند";
		}
	}else
	{
		if(url.match(/lang=far/)){
			name = name.replace('فارسی','');
		}
	}
	
	return name;
}
function doTitle(doc, url){
	var title =ZU.xpathText(doc, "//p[@class='QuranEnglish']");
	if(title == null){
		title = ZU.xpathText(doc, "//p[@class='QuranFarsi']").replace("- تغيير سوره و ترجمه","");
	}else{
		title = title.replace("- Translation","");
	}
		return title;
}
function scrape(doc, url){
	var newQuran = new Zotero.Item('quran');
	
	//translator
	var name =  ZU.xpathText(doc, "//form[@name='khan']/select[@name='tran']/option[@selected]");
	newQuran.creators.push({
					lastName: doTranslator(name, url),
					creatorType: 'translator',
					fieldMode: 1
				});

	//URL
	newQuran.url = url;
	
	//TITLE
	var titleXp = doTitle(doc, url);
	
	
	var QuranTitle = ZU.xpathText(doc, "//select[@name='sura']/option[@selected]").replace(/\d+\-|[\u06F0-\u06F9]+\s\-/,"");
	var aye = decodeURI(url).split("aye=")[1];
	if(aye == null){
		aye = url.match(/ayat=\d+/).toString().split("=")[1];
	}
	if(url.match(/lang=far/)){
		var title ="سوره‌ي"+ QuranTitle + " آيه‌ي" + aye;
	}else{
		title =QuranTitle + "-" + aye;
	}

	
	newQuran.title = title;
	
	//Verse
	newQuran.verse = aye;
	
	//VerseText
	Zotero.debug(ZU.xpathText(doc, "//td [@class='QuranArabic']/p/node()"));
	var versesText = ZU.xpathText(doc, "//td [@class='QuranArabic']").replace(/^\,/,"").split(',');
	var SelectedAye = doConvertor(aye);
	if (versesText[0].match(/[\u06F0-\u06F9]+/) == null){
		var firstVerse = 0 ;
	}else{
		firstVerse = doConvertor(versesText[0].match(/[\u06F0-\u06F9]+/).toString());	
	}
	SelectedAye = SelectedAye - firstVerse;

	newQuran.verseText= versesText[SelectedAye].match(/[\u0600-\u06FF-\s]+/).toString();
	

	//VerseTranslation
 	if(url.match(/lang=eng/)){
		var versesTranslation = ZU.xpathText(doc, "//td [@class='QuranEnglish'][p][p]").replace(/^\,/,"").split(/\(\d+\)/);
 	}else{
 		versesTranslation = ZU.xpathText(doc, "//td [@class='QuranFarsi']").replace(/^\,/,"").split(/\([\u06F0-\u06F9]+\)/); 
 	}
	if(firstVerse == 0 )
			newQuran.verseTranslation=versesTranslation[SelectedAye-1].replace(/^\s\,/,"");
	else
			newQuran.verseTranslation=versesTranslation[SelectedAye].replace(/^\s\,/,"");

	//Chapter,ChapterNumber,Part
	if(url.match(/lang=far/)){
		newQuran.chapter= titleXp.split('-')[0].split(':')[1];
		newQuran.chapterNumber = titleXp.split('-')[0].split(':')[0].match(/[\u06F0-\u06F9]+/).toString();
		newQuran.part = titleXp.match(/\u062C\u0632\u0621\s+[\u06F0-\u06F9]+/).toString().split(' ')[1];
	}else{
		newQuran.chapter= titleXp.split(':')[1].split('Juz')[0].replace(' - ',"");
		newQuran.chapterNumber = titleXp.split(':')[0].match(/\d+/).toString();
		newQuran.part = titleXp.split(':')[1].match(/\d+/).toString();
	}

	newQuran.complete();
}

function doWeb(doc, url) {
	if (detectWeb(doc, url) == "multiple") {
		var items= new Object();
		var quranItems=new Array();
		var verseText;
		if(url.match(/show.php/)){
			verseText = ZU.xpathText(doc, "//td[@class='QuranArabic']/p").split(',');
	
			for each(var item in verseText){
				if (item.match(/[\u06F0-\u06F9]+|\d+/) != null){
					var verseNumber = item.match(/[\u06F0-\u06F9]+|\d+/).toString();
			 		items[doc.location.href + "&aye=" + verseNumber] = "("+ verseNumber +")" + item.match(/[\u0600-\u06FF-\s]+/).toString();
				}
			}
	
			var selectedItems = Zotero.selectItems(items);
		
			//for each(var key in Object.keys(selectedItems)){
			//	quranItems.push(key);
			//}
			//Zotero.Utilities.processDocuments(quranItems, scrape,function(){Zotero.done();});
		}
		if(url.match(/search.php/)){
				var text = ZU.xpathText(doc,"//table[@id = 'AutoNumber12']//tr/td/p[2]").split(/\n\,/);
				var href = ZU.xpathText(doc,"//table[@id = 'AutoNumber12']//tr/td//a/@href").split(',');
				var i = 0;
				for each(var item in text){
					items["http://www.parsquran.com/data/"+href[i].trim()]=item.trim();
					i++;
					//quranItems.push(items);
					
				}
			selectedItems = Zotero.selectItems(items);
		}
		if(selectedItems){
			for each(var key in Object.keys(selectedItems)){
				quranItems.push(key);
			}
		}
		Zotero.Utilities.processDocuments(quranItems, scrape,function(){Zotero.done();});
		
	}
}
