{
	"translatorID": "11fb2e0a-1418-48cd-a640-26ae6456d0e7",
	"label": "khaneKetab",
	"creator": "CRCIS",
	"target": ".*ketab.ir/",
	"minVersion": "1.0",
	"maxVersion": "",
	"priority": 100,
	"inRepository": true,
	"translatorType": 4,
	"browserSupport": "gcsibv",
	"lastUpdated": "2015-07-01 15:24:26"
}

function detectWeb(doc, url)  {
    var result=false;
    //if (url.match(/.*ketab.ir\/modules.php\?name=.*&op=.*&bcode=[0-9]{7}/)) {
    if (url.match(/.*ketab.ir\/modules.php\?name=.*&op=.*&bcode=[0-9]+/)) {
        result="book";
    }
	else if (url.match(/.*ketab.ir\/modules.php\?name=.*/)) {
        if (getBookList(doc).length > 0) {
			result="multiple";
		} else {
			return false;
			}
    } 
    return result;
}

function getBookList(doc) {
	//return ZU.xpath(doc,'//img[@class="bookbox-img"]');
	return ZU.xpath(doc,'//div[@class="bookbox-bookname"]/a');
}


function doWeb(doc, url) {
    var namespace = doc.documentElement.namespaceURI;
    var nsResolver = namespace ? function(prefix) {
        if (prefix == 'x') return namespace; else return null;
    } : null;

    var items = new Object();
    var nextTitle;

    if (detectWeb(doc, url) == "multiple") {
        var itemList = getBookList(doc);
		var items = {};
		for(var i=0, n=itemList.length; i<n; i++) {
			var startIndex = itemList[i].textContent.indexOf("...");
			if(startIndex != -1){
				items[itemList[i].href] = itemList[i].textContent.substring(startIndex+3);
			}
			else{
				if(itemList[i].textContent.length != 0)
				{
					var len = itemList[i].textContent.length/2;
					items[itemList[i].href] = itemList[i].textContent.substring(0,len);
				}
				else
				{
					items[itemList[i].href] = "[بدون عنوان]";
				}
			}
		}
		
		Zotero.selectItems(items, function(selectedItems) {
			if(!selectedItems) return true;
			
			var itemObjs = new Array();

			for (var i in selectedItems) {
				ZU.processDocuments(i, scrapeSingle);	//move this out of the loop when ZU.processDocuments is fixed
			}
		});
			
    } else {
        scrapeSingle(doc,url);
        Zotero.done();
    }
    Zotero.wait();
}

function scrapeSingle(doc,url) {
    var XPath1="//table[@class='borderact']/tbody/tr/td[1]";
    var XPath2="//table[@class='borderact']/tbody/tr/td[2]";
    scrape(doc,url,XPath1,XPath2);
}


//XPath1: XPath to labels ("Title:", "Author:","Publisher:", ...)
//XPath2: XPath to contents ("Story of Civilization","Durant, Will",...)
function scrape(doc,url,XPath1,XPath2) {
	var namespace = doc.documentElement.namespaceURI;
    var nsResolver = namespace ? function(prefix) {
        if (prefix == 'x') return namespace; else return null;
    } : null;

    var itemType="book";
    var newItem = new Zotero.Item(itemType);
    newItem.url = doc.location.href;
    var td1;
    var td2;
    var theXPathObject1=doc.evaluate(XPath1,doc,nsResolver, XPathResult.ANY_TYPE, null);
    var theXPathObject2=doc.evaluate(XPath2,doc,nsResolver, XPathResult.ANY_TYPE, null);
	//get title from first row. first row havn't td2
	var title = theXPathObject1.iterateNext().textContent;
	if(title)
		newItem.title = title;
	else
		{
		/* doc.defaultView.alert("عنوان کتاب مشخص نشده و قابل ذخیره نمی‌باشد.") ;
		return ; */
		newItem.title = "[بدون عنوان]";
		}
	
    while (td1=theXPathObject1.iterateNext()) {
        td2=theXPathObject2.iterateNext();
        if (!td2) break;
        var td1Text=td1.textContent;
        var td2Text=td2.textContent;
        if (td1Text.match(/نويسنده/)) {
            newItem.creators.push(Zotero.Utilities.cleanAuthor(td2Text, "author",false));
        }else if (td1Text.match(/مترجم/)) {
            newItem.creators.push(Zotero.Utilities.cleanAuthor(td2Text, "translator",false));
        }else if (td1Text.match(/ويراستار/)) {
            newItem.creators.push(Zotero.Utilities.cleanAuthor(td2Text, "editor",false));
        } else if (td1Text.match(/ناشر/)) {
            newItem.publisher=td2Text;
        } else if (td1Text.match(/تاریخ نشر/)) {
            newItem.date="13"+td2Text;
        }else if (td1Text.match(/محل نشر/)) {
            newItem.place=td2Text;
        }else if (td1Text.match(/تعداد صفحه/)) {
            newItem.numPages=td2Text;
        } else if (td1Text.match(/موضوع/)) {
            newItem.tags.push(td2Text);
        } else if (td1Text.match(/زبان کتاب/)) {
            if (td2Text.match("فارسي")) {
                newItem.language="fa";
            } else if (td2Text.match("عربى")) {
                newItem.language="ar";
            } else if (td2Text.match("انگلیسی")) {
                newItem.language="en";
            }
        }
    }
    newItem.complete();
    Zotero.debug("newItem: "+newItem);
}